<div class="docs-primary-header component-page-header">
  <mat-chip-list>
    <mat-chip>
      <mat-icon>home</mat-icon>
      <a routerLink="/dashboard">Home</a> / Sub-Categories
    </mat-chip>
  </mat-chip-list>
</div>

<button mat-fab (click)="sidenav1.toggle() && resetform(inputFile)" class="float-button">
  <mat-icon matTooltip="Add Sub-Category">add</mat-icon>
</button>

<div style="padding:15px;" class="appereance">
  <div class="example-container mat-elevation-z2 radius">
    <div class="title">
      <span>SUB CATEGORIES</span>
      <div style="flex-grow:1;"></div>
      <a routerLink="/deleted-subcategory" style="font-size: 16px;padding: 5px;"> Deleted SubCategories</a>&nbsp;
    
      <button mat-raised-button style="cursor: pointer;" (click)="delete()" color="accent">DELETE</button> 
    </div>
    <div class="example-header">
      <mat-form-field>
        <input matInput (keyup)="applyFilter($event.target.value)" placeholder="Filter">
      </mat-form-field>
    </div>

    <mat-table #table [dataSource]="dataSource" matSort>

      <ng-container matColumnDef="sub_category_id">
        <mat-header-cell *matHeaderCellDef mat-sort-header> ID. </mat-header-cell>
        <mat-cell *matCellDef="let element; let i=index"> {{i+1}} </mat-cell>
      </ng-container>

      <ng-container matColumnDef="sub_category_image">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Image </mat-header-cell>
        <mat-cell *matCellDef="let element">
            <img  [src]="element.sub_category_image==null? 'http://13.236.78.106/api/No_image_available.svg.png':element.sub_category_image" width="50px"> 
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="category_name">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Category Name </mat-header-cell>
        <mat-cell *matCellDef="let element"> {{element.category_name}} </mat-cell>
      </ng-container>

      <ng-container matColumnDef="sub_category_name">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Sub-Category Name </mat-header-cell>
        <mat-cell *matCellDef="let element"> {{element.sub_category_name}} </mat-cell>
      </ng-container>

      <ng-container matColumnDef="fields">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Fields </mat-header-cell>
        <mat-cell *matCellDef="let element">

          <mat-accordion>
            <mat-expansion-panel style="box-shadow: none;">
              <mat-expansion-panel-header>
                <mat-panel-title>
                  Inputs
                </mat-panel-title>
              </mat-expansion-panel-header>
              <ng-container *ngFor="let input of element.fields.inputFields">
                <mat-chip-list>
                  <mat-chip class="container">{{input.input}}</mat-chip>
                </mat-chip-list>
              </ng-container>
            </mat-expansion-panel>

            <mat-expansion-panel style="box-shadow: none;" *ngIf="element.fields.dropdownFields != null">
              <mat-expansion-panel-header>
                <mat-panel-title>
                  Dropdowns
                </mat-panel-title>
              </mat-expansion-panel-header>

              <ng-container *ngFor="let dropdown of element.fields.dropdownFields">
                <mat-chip-list>
                  <mat-chip class="container">{{dropdown.dropdown}}</mat-chip>
                </mat-chip-list>
              </ng-container>
            </mat-expansion-panel>
          </mat-accordion>

        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="actions">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Actions </mat-header-cell>
        <mat-cell *matCellDef="let element">
          <button mat-icon-button>
            <mat-icon matTooltip="Edit" (click)="sidenav1.toggle()" (click)="edit(element.sub_category_id)">edit
            </mat-icon>
          </button>

          <!-- <button mat-icon-button>
              <mat-icon matTooltip="Delete" (click)="onDelete(element.id)">delete
              </mat-icon>
            </button> -->
        </mat-cell>
      </ng-container>
      <!-- <ng-container matColumnDef="action"> 
        <mat-header-cell *matHeaderCellDef mat-sort-header> Select </mat-header-cell>
        <mat-cell *matCellDef="let element"><mat-checkbox (change)="sendIDS($event.checked,element.sub_category_id)" color="primary"></mat-checkbox></mat-cell>
      </ng-container> -->
      <ng-container matColumnDef="action">
        <mat-header-cell *matHeaderCellDef>
          <mat-checkbox (change)="alltogglecheck($event.checked,posts)"
          [checked]="allsel"   [indeterminate]="this.intsel > 0 ? true : false"
              >
          </mat-checkbox>
        </mat-header-cell>
        <mat-cell *matCellDef="let row">  
          <mat-checkbox  (change)="sendIDS($event.checked,row.sub_category_id,posts.length)"
                        [checked]="sel">
          </mat-checkbox>
        </mat-cell>
      </ng-container>
      <mat-header-row *matHeaderRowDef="['sub_category_id','sub_category_image', 'category_name', 'sub_category_name', 'fields', 'actions','action']"></mat-header-row>
      <mat-row *matRowDef="let row; columns: ['sub_category_id','sub_category_image', 'category_name', 'sub_category_name', 'fields', 'actions','action']"></mat-row>

    </mat-table>

    <!-- <mat-paginator [length]="100" [pageSize]="5" [pageSizeOptions]="[5, 10, 25, 100]"> -->
        <mat-paginator [length]="100000" [pageSize]="5000" [pageSizeOptions]="[5000, 10000,50000, 100000]">

    </mat-paginator>
  </div>
</div>


<mat-sidenav-container>

  <mat-sidenav #sidenav1 mode="over" opened="false" position="end">
    <mat-toolbar>
      <button mat-icon-button (click)="sidenav1.toggle() && resetform(inputFile)">
        <mat-icon class="icon" matTooltip="Close">close</mat-icon>
      </button>
      <span style="margin-left: 15px;">ADD SUB-CATEGORY</span>
    </mat-toolbar>

    <div style="padding: 0 24px 24px 24px; margin-top: 10px;">
      <form [formGroup]="categoryForm">

        <mat-form-field>
          <mat-select placeholder="Category" formControlName="category_id">
            <mat-option *ngFor="let category of categories" [value]="category.category_id">
              {{ category.category_name }}
            </mat-option>
          </mat-select>
          <mat-error *ngIf="categoryForm.controls['category_id'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
        </mat-form-field>

        <image-upload #inputFile buttonCaption="Select Image" [max]="1"  [uploadedFiles]="showLogo" dropBoxMessage="Image size must be less than 1 MB"
        (change)="uploadImage($event)"></image-upload>

        <mat-form-field>
          <input matInput placeholder="Sub-Category Name" formControlName="sub_category_name">
          <mat-error *ngIf="categoryForm.controls['sub_category_name'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
        </mat-form-field>


        <div style="border: 1px solid lightgray; margin-top: 15px;" formArrayName="addresses">
          <mat-toolbar class="cardtitle">
            <span>Add Inputs</span>
            <div style="flex-grow:1;"></div>
          </mat-toolbar>
          <div *ngFor="let address of categoryForm.controls.addresses.controls; let i=index;">
            <div class="panel-body" [formGroupName]="i">
              <span *ngIf="categoryForm.controls.addresses.controls.length > 1" (click)="removeAddress(i)">
                <a class="a-class">Remove</a>
              </span>
              <mat-form-field class="form-field">
                <input matInput placeholder="Input" formControlName="input">
              </mat-form-field>
            </div>
          </div>
        </div>
        <mat-toolbar class="card-footer">
          <button mat-icon-button (click)="addAddress()">
            <span style="font-family: 'Roboto Condensed', sans-serif;  color: grey; font-size: 16px;">Add More Inputs +</span>
          </button>
        </mat-toolbar>

        <div style="border: 1px solid lightgray; margin-top: 30px;" formArrayName="dropdown">
          <mat-toolbar class="cardtitle">
            <span>Add Dropdowns</span>
            <div style="flex-grow:1;"></div>
          </mat-toolbar>
          <div *ngFor="let dropdown of categoryForm.controls.dropdown.controls; let i=index;">
            <div class="panel-body" [formGroupName]="i">
              <a class="a-class" *ngIf="categoryForm.controls.dropdown.controls.length > 1" (click)="removeDropdown(i)">Remove</a>

              <div class="row">
                <div class="col-md-6">
                  <mat-form-field class="form-field">
                    <input matInput placeholder="Dropdown Name" formControlName="dropdown">
                  </mat-form-field>
                </div>
                <div class="col-md-6">
                  <div style="border: 1px solid lightgray; margin-top: 15px;" formArrayName="dropdownList">
                    <mat-toolbar class="cardtitle">
                      <span>Add Options</span>
                      <div style="flex-grow:1;"></div>
                    </mat-toolbar>
                    <div *ngFor="let option of dropdown.controls.dropdownList.controls; let j=index;">
                      <div class="panel-body" [formGroupName]="j">
                        <span *ngIf="dropdown.controls.dropdownList.controls.length > 1" (click)="removeOption(i)">
                          <a class="a-class">Remove</a>
                        </span>
                        <mat-form-field class="form-field">
                          <input matInput placeholder="Dropdown Option" formControlName="option">
                        </mat-form-field>
                      </div>
                    </div>
                  </div>
                  <mat-toolbar class="card-footer">
                    <a (click)="addOption(i)">
                      <span style="font-family: 'Roboto Condensed', sans-serif;  color: grey; font-size: 16px;">Add More Options +</span>
                    </a>
                  </mat-toolbar>
                </div>
              </div>

            </div>
          </div>
        </div>
        <mat-toolbar class="card-footer" style="margin-bottom: 30px">
          <button mat-icon-button (click)="addDropdown()">
            <span style="font-family: 'Roboto Condensed', sans-serif;  color: grey; font-size: 16px;">Add More Dropdowns +</span>
          </button>
        </mat-toolbar>




        <div style="margin-top: 15px;">
          <a mat-raised-button (click)="resetform(inputFile)" mat-raised-button color="accent" style="margin-left: 5px;">Reset</a>
          <button mat-raised-button color="accent" style="margin-left: 5px;" (click)="sidenav1.toggle() && submit(inputFile)" [disabled]="!categoryForm.valid || Hidden">Submit</button>
        </div>
      </form>
    </div>

  </mat-sidenav>
</mat-sidenav-container>